﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinToolbars;

namespace RibbonWithMaskedEditTool
{
  public partial class Form1 : Form
  {
     
     private string                      m_strLastException     = null;
     private MyCreation                  m_hMyCreation          = null;
     private MaskedEditTool              m_MaskedEditTool1      = null; 
     public const string                 c_KEYMaskedEditTool1   = @"MaskedEditTool1";  




     /// <summary>
     /// 
     /// </summary>
     public string PropLastException
     {
      get { return m_strLastException; }
      set { m_strLastException = value;
           string strW = string.Format( "Form1 Exception = {0} ", m_strLastException ); 
             Console.WriteLine( strW );   
          }
     }



    

    /// <summary>
    /// 
    /// </summary>
    public Form1()
    {
      InitializeComponent();
    }


    /// <summary>
    /// 
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void Form1_Load(object sender, EventArgs e)
    {  
      m_hMyCreation = new MyCreation();
      ultraToolbarsManager1.CreationFilter = m_hMyCreation;
      RegisterTheToolManager( ultraToolbarsManager1 );
      if( m_MaskedEditTool1 != null )
        m_MaskedEditTool1.Value = 26;

    }


    
    /// <summary>
    /// 
    /// </summary>
    /// <param name="hMainToolbarsManager"></param>
    public void RegisterTheToolManager( UltraToolbarsManager hMainToolbarsManager )
    {
      if( hMainToolbarsManager != null )
        {
        RootToolsCollection    toCOL   = hMainToolbarsManager.Tools;
        
        if( toCOL != null )
          {
          try 
            {  
            m_MaskedEditTool1        = toCOL[c_KEYMaskedEditTool1]        as MaskedEditTool; 
            }
          catch( ArgumentException e )
            {
            PropLastException = e.Message; 
            }
          catch( Exception e )
            {
            PropLastException = e.Message; 
            }
          }
        }

    }


    /// <summary>
    /// 
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void ultraToolbarsManager1_ToolValueChanged( object sender, Infragistics.Win.UltraWinToolbars.ToolEventArgs e )
    {
      string strKeyTool = "";
      
      if( e != null && e.Tool != null )
        strKeyTool = e.Tool.Key;

       if( strKeyTool == c_KEYMaskedEditTool1 )
         {
         MaskedEditTool hMaskedEditTool = e.Tool as MaskedEditTool;

         if( hMaskedEditTool != null && m_hMyCreation!= null )
           {
           int nTextOffset = SC2ObjStrInt( hMaskedEditTool.Value );
           m_hMyCreation.PropOffset = nTextOffset;
           }

        }


    }

    
    /// <summary>
    /// 
    /// </summary>
    /// <param name="o2Cast"></param>
    /// <returns></returns>
    public int SC2ObjStrInt( object o2Cast )
    {
      int nInt = -1;
      string strOB = SC2Str( o2Cast );
      
      if( strOB != null && strOB != "" )
        {
        try
          {
          nInt = int.Parse( strOB );
          }
        catch( ArgumentNullException e )
          {
          PropLastException = e.ToString();
          }  
        catch( FormatException e )
          {
          PropLastException = e.ToString();
          } 
        catch( OverflowException e )
          {
          PropLastException = e.ToString();
          } 
        catch( Exception e )
          {
          PropLastException = e.ToString();
          }   
        }
      
      return( nInt );
    }

     /// <summary>
    /// 
    /// </summary>
    /// <param name="o2Cast"></param>
    /// <returns></returns>
    public string SC2Str( object o2Cast )
    {
      string strRet = "";

      if( o2Cast != null && o2Cast.ToString().Length > 0 )
        {
        try
          {
          strRet = o2Cast.ToString();
          }
        catch( InvalidCastException e )
          {
          PropLastException = e.ToString();
          } 
        catch( Exception e )
          {
          PropLastException = e.ToString();
          }    
        }
      
      return( strRet );
    }


  }
}
