﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Text;
using Infragistics.Win;
using Infragistics.Win.UltraWinToolbars;

namespace RibbonWithMaskedEditTool
{
    class MyCreation : IUIElementCreationFilter
    {
        #region IUIElementCreationFilter Members


        private string                      m_strLastException  = null;
        private int                         m_nTextOffset       = 26;

        public int PropOffset
        {
          get { return m_nTextOffset; }
          set { m_nTextOffset = value; }
        }



        /// <summary>
        /// 
        /// </summary>
        public string PropLastException
        {
          get { return m_strLastException; }
          set { m_strLastException = value;
               string strW = string.Format( "MyCreation Exception = {0} ", m_strLastException ); 
                 Console.WriteLine( strW );   
              } 
        }






        /// <summary>
        /// 
        /// </summary>
        /// <param name="parent"></param>
        public void AfterCreateChildElements( UIElement parent )
        {
          
          if( parent is EditorToolBaseUIElement )
            {
            System.Drawing.Drawing2D.GraphicsPath mPath = parent.Path;
            UIElement img = parent.ChildElements[0];
            img.Rect = new Rectangle( new Point( parent.Rect.X + 2, img.Rect.Y ), img.Rect.Size );
            UIElement text = parent.ChildElements[1];
            text.Rect = new Rectangle( new Point( parent.Rect.X + m_nTextOffset, text.Rect.Y ), text.Rect.Size );
            }
        }



        /// <summary>
        /// 
        /// </summary>
        /// <param name="parent"></param>
        /// <returns></returns>
        public bool BeforeCreateChildElements(UIElement parent)
        {
            return false; 
        }







        #endregion
    }
}
